<?php

namespace SenSai;

use ManiaControl\Callbacks\CallbackListener;
use ManiaControl\Callbacks\CallbackManager;
use ManiaControl\Callbacks\Callbacks;
use ManiaControl\Callbacks\Structures\ManiaPlanet\StartEndStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnEliteEndTurnStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnEliteStartTurnStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnHitStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnScoresStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnShotDenyStructure;
use ManiaControl\Commands\CommandListener;
use FML\Controls\Control;
use FML\Controls\Frame;
use FML\Controls\Labels\Label_Button;
use FML\Controls\Labels\Label_Text;
use FML\Controls\Quad;
use FML\Controls\Quads\Quad_BgRaceScore2;
use FML\Controls\Quads\Quad_BgsPlayerCard;
use FML\Controls\Quads\Quad_Emblems;
use FML\Controls\Quads\Quad_Icons64x64_1;
use FML\Controls\Quads\Quad_Icons128x128_1;
use FML\Controls\Quads\Quad_UIConstruction_Buttons;
use FML\ManiaLink;
use ManiaControl\Files\FileUtil;
use ManiaControl\ManiaControl;
use FML\Controls\Audio;
use ManiaControl\Players\Player;
use ManiaControl\Players\PlayerManager;
use ManiaControl\Manialinks\ManialinkPageAnswerListener;
use ManiaControl\Manialinks\IconManager;
use ManiaControl\Manialinks\ManialinkManager;
use ManiaControl\Admin\AuthenticationManager;
use ManiaControl\Plugins\Plugin;
use ManiaControl\Settings\SettingManager;
use ManiaControl\Callbacks\TimerListener;
use ManiaControl\Callbacks\TimerManager;



/**
 * ManiaControl Sound Plugin
 *
 * @author G]R [SG-1] Sen-Sai
 */
class GRSoundsElite implements CommandListener, CallbackListener, ManialinkPageAnswerListener, TimerListener,  Plugin {
	/**
	 * Constants
	 */
	const PLUGIN_ID              = 114;
	const PLUGIN_VERSION         = 0.21;
	const PLUGIN_NAME            = 'GRSoundsElite';
	const PLUGIN_AUTHOR          = 'G]R [SG-1]Sen-sai';
	const DATE                   = 'd-m-y h:i:sa T';
	const MLID_SOUNDS            = 'GRSoundsPlugin.MLID';
	const MLID_MESSAGEWIDGET	 = 'GRSoundsPlugin.MessageWidget';
	const SHOWN_MAIN_WINDOW      = -1;
	const SETTING_SOUND_START    = 'Sound at begin of turn';
	const SETTING_SOUND_HATTRICK = 'Sound at defenders hattrick';
	const SETTING_SOUND_DENIED   = 'Sound attacker hits rocket';
	const SETTING_SOUND_HIT50M   = 'Sound over 50 meter hit';
	const SETTING_SOUND_F6       = 'Sound chat command f6';
	const SETTING_SOUND_EZ       = 'Sound chat command Eezzee';
	const SETTING_SOUND_NEXT     = 'Sound chat command Next';
	const SETTING_SOUND_LOAD     = 'Sound new map loading';
	const SETTING_SOUND_WINNER   = 'Sound telling what team won';


	/**
	 * Private properties
	 */
	/** @var maniaControl $maniaControl */
	private $maniaControl = null;
	private $kills = array();
	private $shotsDenied = 0;
	private $warmup = false;
	private $hattrick = array();
	private $messageShow = false;
	private $pluginPath = "";
	private $sounds = array();

	/**
	 * Prepares the Plugin
	 *
	 * @param ManiaControl $maniaControl
	 * @return mixed
	 */
	public static function prepare(ManiaControl $maniaControl) {

		$GLOBALS['death']=false;
		$GLOBALS['page']=1;
		$GLOBALS['teamredleads']=false;
		$GLOBALS['teamblueleads']=false;

	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::load()
	 */
	public function load(ManiaControl $maniaControl) {

		$this->maniaControl = $maniaControl;
		$this->pluginPath =  "http://designburo.nl/shootmania/sounds/";



		// Settings
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_START, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_HATTRICK, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_DENIED, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_F6, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_EZ, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_NEXT, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_HIT50M, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_LOAD, true);
		$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_WINNER, true);

		// new callbacks
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::MP_WARMUP_START, $this, 'cbWarmUpStart');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::MP_WARMUP_END, $this, 'cbWarmUpEnd');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::SM_ELITE_STARTTURN, $this, 'cbEliteStartTurn');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::SM_ELITE_ENDTURN, $this, 'cbEliteEndTurn');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::BEGINMAP, $this, 'cbBeginMap');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::MP_STARTROUNDSTART, $this, 'cbStartRoundStart');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::SM_ONHIT, $this, 'cbOnHit');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::SM_ONSHOTDENY, $this, 'cbOnShotDeny');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::MP_PODIUMSTART, $this, 'cbPodiumStart');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::SM_SCORES, $this, 'cbScores');

		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERCONNECT, $this, 'preloadSoundstoLogin');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERDISCONNECT, $this, 'playerDisconnect');
		$this->maniaControl->getCommandManager()->registerCommandListener('grent', $this, 'glimratten');
		$this->maniaControl->getCommandManager()->registerCommandListener('eyes', $this, 'eyes');
		$this->maniaControl->getCommandManager()->registerCommandListener('shootmania', $this, 'shootmania');
		$this->maniaControl->getCommandManager()->registerCommandListener('grwnkr', $this, 'wanker');
		$this->maniaControl->getCommandManager()->registerCommandListener('grlaugh', $this, 'laugh');
		$this->maniaControl->getCommandManager()->registerCommandListener('grblah', $this, 'blah');
		$this->maniaControl->getCommandManager()->registerCommandListener('grnein', $this, 'nein');
		$this->maniaControl->getCommandManager()->registerCommandListener('grgood', $this, 'grgood', false, false);
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_F6)) {
			$this->maniaControl->getCommandManager()->registerCommandListener('f6', $this, 'setReady');
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_EZ)) {
			$this->maniaControl->getCommandManager()->registerCommandListener('grez', $this, 'grez');
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_NEXT)) {
			$this->maniaControl->getCommandManager()->registerCommandListener('grnext', $this, 'grnext');
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_START)) {
			$this->sounds[0]['trigger']  = 'beginround';
			$this->sounds[0]['file']     = "play2.ogg";
			$this->sounds[0]['duration'] = 3300;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_DENIED)) {
			$this->sounds[1]['trigger']  = 'denied';
			$this->sounds[1]['file']     = "denied.ogg";
			$this->sounds[1]['duration'] = 2200;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_HIT50M)) {
			$this->sounds[2]['trigger']  = 'hit50m';
			$this->sounds[2]['file']     = "shot50m.ogg";
			$this->sounds[2]['duration'] = 4100;
		}

		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_HATTRICK)) {
			$this->sounds[3]['trigger']  = 'hattrick';
			$this->sounds[3]['file']     = "hattrick.ogg";
			$this->sounds[3]['duration'] = 3300;
		}

		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_F6)) {
			$this->sounds[4]['trigger']  = 'f6';
			$this->sounds[4]['file']     = "f6.ogg";
			$this->sounds[4]['duration'] = 3500;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_EZ)) {
			$this->sounds[5]['trigger']  = 'grez';
			$this->sounds[5]['file']     = "ez.ogg";
			$this->sounds[5]['duration'] = 1660;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_NEXT)) {
			$this->sounds[6]['trigger']  = 'grnext';
			$this->sounds[6]['file']     = "next.ogg";
			$this->sounds[6]['duration'] = 1250;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_LOAD)) {
			$this->sounds[7]['trigger']  = 'loading';
			$this->sounds[7]['file']     = "loading.ogg";
			$this->sounds[7]['duration'] = 4000;
		}
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_WINNER)) {
			$this->maniaControl->getSettingManager()->setSetting($this, self::SETTING_SOUND_LOAD, false);
			$this->maniaControl->getSettingManager()->setSetting($this, self::SETTING_SOUND_START, false);
			$this->sounds[14]['trigger']  = 'bluewin';
			$this->sounds[14]['file']     = "blue_team_is_the_winner.ogg";
			$this->sounds[14]['duration'] = 2900;
			$this->sounds[15]['trigger']  = 'redwin';
			$this->sounds[15]['file']     = "red_team_is_the_winner.ogg";
			$this->sounds[15]['duration'] = 2900;
			$this->sounds[16]['trigger']  = 'bluelead';
			$this->sounds[16]['file']     = "blue_lead.ogg";
			$this->sounds[16]['duration'] = 2900;
			$this->sounds[17]['trigger']  = 'redlead';
			$this->sounds[17]['file']     = "red_lead.ogg";
			$this->sounds[17]['duration'] = 2900;
		}

		$this->preloadSounds();
		$this->loadPlayers();
		return true;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::unload()
	 */
	public function unload() {
	}

	public function loadPlayers() {
		$players = $this->maniaControl->getPlayerManager()->getPlayers();
		foreach ($players as $player)
		{
			$this->kills[$player->login]=0;
		}
	}


	public function displayMessage($message,$timer=2000,$valign="top",$image=false)
	{
		if($this->messageShow) return;
		$maniaLink = new ManiaLink(self::MLID_MESSAGEWIDGET);
		if($valign=="bottom")
		{
			$imageY=-65;
			if($image)
			{
				$textY=-46;
			}
			else
			{
				$textY=-60;
			}
		}
		else
		{
			$imageY=65;
			if($image)
			{
				$textY=46;
			}
			else
			{
				$textY=65;
			}
		}

		if($image)
		{
			$quad = new Quad();
			$maniaLink->addChild($quad);
			$quad->setSize(20,20);
			$quad->setPosition(0,$imageY);
			$quad->setImage($image);
			$quad->setZ(3);
		}

		$label = new Label_Text();
		$maniaLink->addChild($label);
		$label->setPosition(0,$textY);
		$label->setZ(50);
		$label->setText($message);
		$label->setTextSize(3);
		$label->setAutoNewLine(1);

		$label->setStyle("TextCongratsBig");
		$label->setHAlign(Control::CENTER);
		$this->maniaControl->getManialinkManager()->sendManialink($maniaLink, false);
		//registerOneTimeListening(TimerListener $listener, $method, $milliSeconds)
		$this->maniaControl->getTimerManager()->registerOneTimeListening($this, 'closeMessage', $timer);
		$this->messageShow=true;
	}

	public function closeMessage()
	{
		$this->maniaControl->getManialinkManager()->hideManialink(self::MLID_MESSAGEWIDGET);
		$this->messageShow=false;
	}




	public function playerDisconnect(player $player) {
	}


	public function preloadSoundstoLogin(player $player) {
		$this->kills[$player->login]=0;
		$manialink = new ManiaLink(self::MLID_SOUNDS);
		foreach ($this->sounds as $sound)
		{
			$vox = new Audio();
			$vox->setData($this->pluginPath . $sound['file']);
			$vox->setPlay("1");
			$vox->setLooping("0");
			$vox->setVolume(0);
			$vox->setVisible(false);
			$manialink->add($vox);
		}


		$this->maniaControl->getManialinkManager()->sendManialink($manialink,$player);
	}

	public function preloadSounds() {
		$manialink = new ManiaLink(self::MLID_SOUNDS);
		$this->maniaControl->getChat()->sendChat('$fffPreloading sounds..', null, false);
		foreach ($this->sounds as $sound)
		{
			$vox = new Audio();
			$vox->setData($this->pluginPath . $sound['file']);
			$vox->setPlay("1");
			$vox->setLooping("0");
			$vox->setVolume(0);
			$vox->setVisible(false);
			$manialink->add($vox);
		}

		$this->maniaControl->getManialinkManager()->sendManialink($manialink);
	}



	public function playSound($trigger,$vol=false,$player=false)
	{
		if(!$vol) $vol=1;
		foreach ($this->sounds as $sound)
		{
			if (strtolower($sound['trigger'])==strtolower($trigger))
			{
				$manialink = new ManiaLink(self::MLID_SOUNDS);
				$vox = new Audio();
				$vox->setData($this->pluginPath . $sound['file']);
				$vox->setPlay("1");
				$vox->setLooping("0");
				$vox->setVolume($vol);
				$vox->setVisible(false);
				$manialink->add($vox);
				if(!$player)
				{
					$this->maniaControl->getManialinkManager()->sendManialink($manialink,null,(int)$sound['duration'],false);
				}
				else
				{
					$this->maniaControl->getManialinkManager()->sendManialink($manialink,$player,(int)$sound['duration']);
				}
				return;
			}
		}
	}


	public function cbStartRoundStart(StartEndStructure $structure) {
		$GLOBALS['death']=false;
		foreach ($this->kills as $login => $nrkills)
		{
			$this->kills[$login]=0;
		}
		unset($login);
		unset($nrkills);
	}



	public function cbOnShotDeny(onShotDenyStructure $structure) {
		if($this->warmup) return;
		if (!$this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_DENIED)) return;
		if($this->maniaControl->getServer()->titleId == 'SMStormElite@nadeolabs')
		{
			if ($GLOBALS['elite_attacker']==$structure->getShooter()->login) {
				$this->shotsDenied++;
				if ($this->shotsDenied == 1) {
					$msg = $structure->getShooter()->nickname . "\$z\$fff denies a shot";
				} else {
					$msg = $structure->getShooter()->nickname . "\$z\$fff denied \$w" . $this->shotsDenied . "\$z shots";
				}
				$this->displayMessage($msg, 2000, "top");
				$this->playSound("denied", .6);
			}
		}
	}

	public function cbOnHit(onHitStructure $structure) {

		if($this->warmup) return;
		if($this->maniaControl->getServer()->titleId == 'SMStormElite@nadeolabs')
		{
			$hitDist = $structure->getDistance();
			$schieter =  $structure->getShooter()->login;
			if(isset($this->hattrick[$schieter])) {
				$this->hattrick[$schieter]['cnt']++;
			}
			if (!$this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_HIT50M)) return;
			if ($hitDist >= 50) {
				$shooter = $structure->getShooter()->nickname;
				$victim = $structure->getVictim()->nickname;
				$weapon="";
				if ($structure->getWeapon() == "1") { $weapon = "laser";}
				if ($structure->getWeapon() == "2") { $weapon = "rocket";}
				if ($structure->getWeapon() == "3") { $weapon = "nucleus";}
				if ($structure->getWeapon() == "5") { $weapon = "arrow";}
				$this->playSound('hit50m',0.7); // Long Distance shot / Sniper shot
				$msg = $shooter . "\$fff\$z just made a \$w".round($hitDist,2)."\$n meter " . $weapon . " hit on ".$victim;

				$this->maniaControl->getChat()->sendChat($msg, null, false);
			}
		}
	}

	public function cbBeginMap() {
		$GLOBALS['winner']=false;
		$GLOBALS['teamwinner']=false;
		$GLOBALS['teamredleads']=false;
		$GLOBALS['teamblueleads']=false;
	}


	public function cbPodiumStart() {
		if($this->maniaControl->getServer()->titleId == 'SMStormElite@nadeolabs')
		{
			if (!$this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_LOAD)) return;
			if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_WINNER)) return;
			$this->playSound("loading",1);
		}
	}

	public function cbWarmUpStart() {
		$this->warmup=true;
		$this->winTeam=-1;
	}
	public function cbWarmUpEnd() {
		$this->warmup=false;

	}

	public function cbEliteStartTurn(OnEliteStartTurnStructure $structure) {
		if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_START)) {
			$this->playSound("beginround", 1);
		}
		$GLOBALS['teamwinner']=false;
		$this->hattrick = array();
		$GLOBALS['elite_attacker'] = $structure->getAttacker()->login;
		$GLOBALS['elite_defender'][1]=false;
		$GLOBALS['elite_defender'][2]=false;
		$GLOBALS['elite_defender'][3]=false;
		$this->shotsDenied = 0;
		$t=1;
		foreach ($structure->getDefenders() as $def) {
			$logi = $def->login;
			$GLOBALS['elite_defender'][$t]=$logi;
			$this->hattrick[$logi]['cnt']=0;
			$this->hattrick[$logi]['nick']=$def->nickname;
			$t++;
		}
	}

	public function cbEliteEndTurn(OnEliteEndTurnStructure $structure) {
		if(isset($GLOBALS['elite_attacker'])) {
			$lognaam = $GLOBALS['elite_attacker'];

			foreach ($this->hattrick as $val) {
				if ($val['cnt'] == 3) {
					$attNick = $this->maniaControl->getPlayerManager()->getPlayer($lognaam);
					$msg     = $val['nick'] . "\$z\$fff just made a \$wHattrick\$n on " . $attNick->nickname;
					if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_HATTRICK)) {
						$this->playSound('hattrick', 1);
						$this->displayMessage($msg, 5000, "top");
					}
				}
			}
		}
	}

	public function cbScores(OnScoresStructure $structure) {
		if ( $structure->getSection() == 'EndMap' ) {
			$winteam = $structure->getWinnerTeamId();
			if ( $winteam === 0 ) {
				if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_WINNER)) {
					$this->playSound('bluewin', 1);
				}
			}
			if ($winteam === 1 ) {
				if ($this->maniaControl->getSettingManager()->getSettingValue($this, self::SETTING_SOUND_WINNER)) {
					$this->playSound('redwin', 1);
				}
			}
		}
		if ($structure->getSection() == 'EndTurn') {
			$scores = $structure->getTeamScores();
			$teamscore = array();
			$teamscore[0]['pts'] = $scores[0]->getMapPoints();
			$teamscore[1]['pts'] = $scores[1]->getMapPoints();

			$difference = $teamscore[0]['pts'] - $teamscore[1]['pts'];
			if( $difference == 0 ) {
				$GLOBALS['teamblueleads']=false;
				$GLOBALS['teamredleads']=false;
				return;
			}
			if( $difference == 1 && $GLOBALS['teamblueleads'] === false ) { // blue take the lead
				$GLOBALS['teamblueleads'] = true;
				$msg = $scores[0]->getName() . "\$z\$fff takes the lead!";
				$this->playSound('bluelead',1);
				$this->displayMessage($msg,5000,"top");
			}
			if( $difference == -1 && $GLOBALS['teamredleads'] === false ) { // red take the lead
				$GLOBALS['teamredleads'] = true;
				$msg = $scores[1]->getName() . "\$z\$fff takes the lead!";
				$this->playSound('redlead',1);
				$this->displayMessage($msg,5000,"top");
			}

		}
	}


	public function checkMute(Player $player) {
		if( $player->isMuted() ) {
			$this->maniaControl->getChat()->sendError("You can't use this command because you are muted!", $player);
			return true;
		} else return false;
	}

	public function setReady(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$trigger="f6";
		$msg = '$g[$<' . $player->nickname . '$>$s] says : Please set ready by pressing F6!';
		$this->maniaControl->getChat()->sendChat($msg, null, false);
		$this->playSound($trigger);
	}

	public function grez(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$trigger="grez";
		$msg = '$g[$<' . $player->nickname . '$>$s] says : Eeezee! :-)';
		$this->maniaControl->getChat()->sendChat($msg, null, false);
		$this->playSound($trigger);
	}

	public function grnext(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$trigger="grnext";
		$msg = '$g[$<' . $player->nickname . '$>$s] says : Next! :-)';
		$this->maniaControl->getChat()->sendChat($msg, null, false);
		$this->playSound($trigger);
	}

	public function glimratten(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[10]['trigger'] = 'house';
		$this->sounds[10]['file'] = "house.ogg";
		$this->sounds[10]['duration'] = 6600;
		$trigger="house";
		$this->playSound($trigger);
	}

	public function eyes(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[11]['trigger'] = 'eyes';
		$this->sounds[11]['file'] = "closeeyes.ogg";
		$this->sounds[11]['duration'] = 3090;
		$trigger="eyes";
		$this->playSound($trigger);
	}

	public function shootmania(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[12]['trigger'] = 'shootmania';
		$this->sounds[12]['file'] = "play_shootmania.ogg";
		$this->sounds[12]['duration'] = 19770;
		$trigger="shootmania";
		$this->playSound($trigger);
	}

	public function wanker(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[13]['trigger'] = 'wanker';
		$this->sounds[13]['file'] = "wanker.ogg";
		$this->sounds[13]['duration'] = 2100;
		$trigger="wanker";
		$this->playSound($trigger);
	}

	public function laugh(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[18]['trigger'] = 'laugh';
		$this->sounds[18]['file'] = "1_lach.ogg";
		$this->sounds[18]['duration'] = 2500;
		$trigger="laugh";
		$this->playSound($trigger);
	}

	public function blah(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[19]['trigger'] = 'blah';
		$this->sounds[19]['file'] = "blah_blah.ogg";
		$this->sounds[19]['duration'] = 5500;
		$trigger="blah";
		$this->playSound($trigger);
	}

	public function nein(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[20]['trigger'] = 'nein';
		$this->sounds[20]['file'] = "nein_nein.ogg";
		$this->sounds[20]['duration'] = 2900;
		$trigger="nein";
		$this->playSound($trigger);
	}
	public function grgood(array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[21]['trigger'] = 'grgood';
		$this->sounds[21]['file'] = "ashvsevildead.ogg";
		$this->sounds[21]['duration'] = 5000;
		$trigger="grgood";
		$this->playSound($trigger);
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getId()
	 */
	public static function getId() {
		return self::PLUGIN_ID;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getName()
	 */
	public static function getName() {
		return self::PLUGIN_NAME;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getVersion()
	 */
	public static function getVersion() {
		return self::PLUGIN_VERSION;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getAuthor()
	 */
	public static function getAuthor() {
		return self::PLUGIN_AUTHOR;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getDescription()
	 */
	public static function getDescription() {
		return 'Core extender plugin for sound control.';
	}


}
